// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/RadarDetection.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/radar_detection__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `position`
#include "performance_test/msg/detail/point__functions.h"
// Member `velocity`
#include "performance_test/msg/detail/vector3__functions.h"

bool
performance_test__msg__RadarDetection__init(performance_test__msg__RadarDetection * msg)
{
  if (!msg) {
    return false;
  }
  // detection_id
  // position
  if (!performance_test__msg__Point__init(&msg->position)) {
    performance_test__msg__RadarDetection__fini(msg);
    return false;
  }
  // velocity
  if (!performance_test__msg__Vector3__init(&msg->velocity)) {
    performance_test__msg__RadarDetection__fini(msg);
    return false;
  }
  // amplitude
  // time
  // id
  return true;
}

void
performance_test__msg__RadarDetection__fini(performance_test__msg__RadarDetection * msg)
{
  if (!msg) {
    return;
  }
  // detection_id
  // position
  performance_test__msg__Point__fini(&msg->position);
  // velocity
  performance_test__msg__Vector3__fini(&msg->velocity);
  // amplitude
  // time
  // id
}

performance_test__msg__RadarDetection *
performance_test__msg__RadarDetection__create()
{
  performance_test__msg__RadarDetection * msg = (performance_test__msg__RadarDetection *)malloc(sizeof(performance_test__msg__RadarDetection));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__RadarDetection));
  bool success = performance_test__msg__RadarDetection__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__RadarDetection__destroy(performance_test__msg__RadarDetection * msg)
{
  if (msg) {
    performance_test__msg__RadarDetection__fini(msg);
  }
  free(msg);
}


bool
performance_test__msg__RadarDetection__Sequence__init(performance_test__msg__RadarDetection__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  performance_test__msg__RadarDetection * data = NULL;
  if (size) {
    data = (performance_test__msg__RadarDetection *)calloc(size, sizeof(performance_test__msg__RadarDetection));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__RadarDetection__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__RadarDetection__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__RadarDetection__Sequence__fini(performance_test__msg__RadarDetection__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__RadarDetection__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__RadarDetection__Sequence *
performance_test__msg__RadarDetection__Sequence__create(size_t size)
{
  performance_test__msg__RadarDetection__Sequence * array = (performance_test__msg__RadarDetection__Sequence *)malloc(sizeof(performance_test__msg__RadarDetection__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__RadarDetection__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
performance_test__msg__RadarDetection__Sequence__destroy(performance_test__msg__RadarDetection__Sequence * array)
{
  if (array) {
    performance_test__msg__RadarDetection__Sequence__fini(array);
  }
  free(array);
}
