// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from performance_test:msg/RadarDetection.idl
// generated code does not contain a copyright notice

#ifndef PERFORMANCE_TEST__MSG__DETAIL__RADAR_DETECTION__STRUCT_HPP_
#define PERFORMANCE_TEST__MSG__DETAIL__RADAR_DETECTION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'position'
#include "performance_test/msg/detail/point__struct.hpp"
// Member 'velocity'
#include "performance_test/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__performance_test__msg__RadarDetection __attribute__((deprecated))
#else
# define DEPRECATED__performance_test__msg__RadarDetection __declspec(deprecated)
#endif

namespace performance_test
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarDetection_
{
  using Type = RadarDetection_<ContainerAllocator>;

  explicit RadarDetection_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : position(_init),
    velocity(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->detection_id = 0;
      this->amplitude = 0.0;
      this->time = 0ll;
      this->id = 0ull;
    }
  }

  explicit RadarDetection_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : position(_alloc, _init),
    velocity(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->detection_id = 0;
      this->amplitude = 0.0;
      this->time = 0ll;
      this->id = 0ull;
    }
  }

  // field types and members
  using _detection_id_type =
    uint16_t;
  _detection_id_type detection_id;
  using _position_type =
    performance_test::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _velocity_type =
    performance_test::msg::Vector3_<ContainerAllocator>;
  _velocity_type velocity;
  using _amplitude_type =
    double;
  _amplitude_type amplitude;
  using _time_type =
    int64_t;
  _time_type time;
  using _id_type =
    uint64_t;
  _id_type id;

  // setters for named parameter idiom
  Type & set__detection_id(
    const uint16_t & _arg)
  {
    this->detection_id = _arg;
    return *this;
  }
  Type & set__position(
    const performance_test::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__velocity(
    const performance_test::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__amplitude(
    const double & _arg)
  {
    this->amplitude = _arg;
    return *this;
  }
  Type & set__time(
    const int64_t & _arg)
  {
    this->time = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    performance_test::msg::RadarDetection_<ContainerAllocator> *;
  using ConstRawPtr =
    const performance_test::msg::RadarDetection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<performance_test::msg::RadarDetection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<performance_test::msg::RadarDetection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      performance_test::msg::RadarDetection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<performance_test::msg::RadarDetection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      performance_test::msg::RadarDetection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<performance_test::msg::RadarDetection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<performance_test::msg::RadarDetection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<performance_test::msg::RadarDetection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__performance_test__msg__RadarDetection
    std::shared_ptr<performance_test::msg::RadarDetection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__performance_test__msg__RadarDetection
    std::shared_ptr<performance_test::msg::RadarDetection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarDetection_ & other) const
  {
    if (this->detection_id != other.detection_id) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->amplitude != other.amplitude) {
      return false;
    }
    if (this->time != other.time) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarDetection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarDetection_

// alias to use template instance with default allocator
using RadarDetection =
  performance_test::msg::RadarDetection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace performance_test

#endif  // PERFORMANCE_TEST__MSG__DETAIL__RADAR_DETECTION__STRUCT_HPP_
