// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from performance_test:msg/RadarTrack.idl
// generated code does not contain a copyright notice

#ifndef PERFORMANCE_TEST__MSG__DETAIL__RADAR_TRACK__STRUCT_HPP_
#define PERFORMANCE_TEST__MSG__DETAIL__RADAR_TRACK__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'track_shape'
#include "performance_test/msg/detail/polygon__struct.hpp"
// Member 'linear_velocity'
// Member 'linear_acceleration'
#include "performance_test/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__performance_test__msg__RadarTrack __attribute__((deprecated))
#else
# define DEPRECATED__performance_test__msg__RadarTrack __declspec(deprecated)
#endif

namespace performance_test
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarTrack_
{
  using Type = RadarTrack_<ContainerAllocator>;

  explicit RadarTrack_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : track_shape(_init),
    linear_velocity(_init),
    linear_acceleration(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->track_id = 0;
      this->time = 0ll;
      this->id = 0ull;
    }
  }

  explicit RadarTrack_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : track_shape(_alloc, _init),
    linear_velocity(_alloc, _init),
    linear_acceleration(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->track_id = 0;
      this->time = 0ll;
      this->id = 0ull;
    }
  }

  // field types and members
  using _track_id_type =
    uint16_t;
  _track_id_type track_id;
  using _track_shape_type =
    performance_test::msg::Polygon_<ContainerAllocator>;
  _track_shape_type track_shape;
  using _linear_velocity_type =
    performance_test::msg::Vector3_<ContainerAllocator>;
  _linear_velocity_type linear_velocity;
  using _linear_acceleration_type =
    performance_test::msg::Vector3_<ContainerAllocator>;
  _linear_acceleration_type linear_acceleration;
  using _time_type =
    int64_t;
  _time_type time;
  using _id_type =
    uint64_t;
  _id_type id;

  // setters for named parameter idiom
  Type & set__track_id(
    const uint16_t & _arg)
  {
    this->track_id = _arg;
    return *this;
  }
  Type & set__track_shape(
    const performance_test::msg::Polygon_<ContainerAllocator> & _arg)
  {
    this->track_shape = _arg;
    return *this;
  }
  Type & set__linear_velocity(
    const performance_test::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->linear_velocity = _arg;
    return *this;
  }
  Type & set__linear_acceleration(
    const performance_test::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->linear_acceleration = _arg;
    return *this;
  }
  Type & set__time(
    const int64_t & _arg)
  {
    this->time = _arg;
    return *this;
  }
  Type & set__id(
    const uint64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    performance_test::msg::RadarTrack_<ContainerAllocator> *;
  using ConstRawPtr =
    const performance_test::msg::RadarTrack_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<performance_test::msg::RadarTrack_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<performance_test::msg::RadarTrack_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      performance_test::msg::RadarTrack_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<performance_test::msg::RadarTrack_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      performance_test::msg::RadarTrack_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<performance_test::msg::RadarTrack_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<performance_test::msg::RadarTrack_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<performance_test::msg::RadarTrack_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__performance_test__msg__RadarTrack
    std::shared_ptr<performance_test::msg::RadarTrack_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__performance_test__msg__RadarTrack
    std::shared_ptr<performance_test::msg::RadarTrack_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarTrack_ & other) const
  {
    if (this->track_id != other.track_id) {
      return false;
    }
    if (this->track_shape != other.track_shape) {
      return false;
    }
    if (this->linear_velocity != other.linear_velocity) {
      return false;
    }
    if (this->linear_acceleration != other.linear_acceleration) {
      return false;
    }
    if (this->time != other.time) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarTrack_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarTrack_

// alias to use template instance with default allocator
using RadarTrack =
  performance_test::msg::RadarTrack_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace performance_test

#endif  // PERFORMANCE_TEST__MSG__DETAIL__RADAR_TRACK__STRUCT_HPP_
