// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/NavSatFix.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/nav_sat_fix__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "performance_test/msg/detail/header__functions.h"
// Member `status`
#include "performance_test/msg/detail/nav_sat_status__functions.h"

bool
performance_test__msg__NavSatFix__init(performance_test__msg__NavSatFix * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!performance_test__msg__Header__init(&msg->header)) {
    performance_test__msg__NavSatFix__fini(msg);
    return false;
  }
  // status
  if (!performance_test__msg__NavSatStatus__init(&msg->status)) {
    performance_test__msg__NavSatFix__fini(msg);
    return false;
  }
  // latitude
  // longitude
  // altitude
  // position_covariance
  // position_covariance_type
  // time
  // id
  return true;
}

void
performance_test__msg__NavSatFix__fini(performance_test__msg__NavSatFix * msg)
{
  if (!msg) {
    return;
  }
  // header
  performance_test__msg__Header__fini(&msg->header);
  // status
  performance_test__msg__NavSatStatus__fini(&msg->status);
  // latitude
  // longitude
  // altitude
  // position_covariance
  // position_covariance_type
  // time
  // id
}

performance_test__msg__NavSatFix *
performance_test__msg__NavSatFix__create()
{
  performance_test__msg__NavSatFix * msg = (performance_test__msg__NavSatFix *)malloc(sizeof(performance_test__msg__NavSatFix));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__NavSatFix));
  bool success = performance_test__msg__NavSatFix__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__NavSatFix__destroy(performance_test__msg__NavSatFix * msg)
{
  if (msg) {
    performance_test__msg__NavSatFix__fini(msg);
  }
  free(msg);
}


bool
performance_test__msg__NavSatFix__Sequence__init(performance_test__msg__NavSatFix__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  performance_test__msg__NavSatFix * data = NULL;
  if (size) {
    data = (performance_test__msg__NavSatFix *)calloc(size, sizeof(performance_test__msg__NavSatFix));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__NavSatFix__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__NavSatFix__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__NavSatFix__Sequence__fini(performance_test__msg__NavSatFix__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__NavSatFix__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__NavSatFix__Sequence *
performance_test__msg__NavSatFix__Sequence__create(size_t size)
{
  performance_test__msg__NavSatFix__Sequence * array = (performance_test__msg__NavSatFix__Sequence *)malloc(sizeof(performance_test__msg__NavSatFix__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__NavSatFix__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
performance_test__msg__NavSatFix__Sequence__destroy(performance_test__msg__NavSatFix__Sequence * array)
{
  if (array) {
    performance_test__msg__NavSatFix__Sequence__fini(array);
  }
  free(array);
}
