// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/PointCloud8m.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/point_cloud8m__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "performance_test/msg/detail/header__functions.h"
// Member `fields`
#include "performance_test/msg/detail/point_field__functions.h"

bool
performance_test__msg__PointCloud8m__init(performance_test__msg__PointCloud8m * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!performance_test__msg__Header__init(&msg->header)) {
    performance_test__msg__PointCloud8m__fini(msg);
    return false;
  }
  // height
  // width
  // fields
  for (size_t i = 0; i < 8; ++i) {
    if (!performance_test__msg__PointField__init(&msg->fields[i])) {
      performance_test__msg__PointCloud8m__fini(msg);
      return false;
    }
  }
  // is_bigendian
  // point_step
  // row_step
  // data
  // is_dense
  // time
  // id
  return true;
}

void
performance_test__msg__PointCloud8m__fini(performance_test__msg__PointCloud8m * msg)
{
  if (!msg) {
    return;
  }
  // header
  performance_test__msg__Header__fini(&msg->header);
  // height
  // width
  // fields
  for (size_t i = 0; i < 8; ++i) {
    performance_test__msg__PointField__fini(&msg->fields[i]);
  }
  // is_bigendian
  // point_step
  // row_step
  // data
  // is_dense
  // time
  // id
}

performance_test__msg__PointCloud8m *
performance_test__msg__PointCloud8m__create()
{
  performance_test__msg__PointCloud8m * msg = (performance_test__msg__PointCloud8m *)malloc(sizeof(performance_test__msg__PointCloud8m));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__PointCloud8m));
  bool success = performance_test__msg__PointCloud8m__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__PointCloud8m__destroy(performance_test__msg__PointCloud8m * msg)
{
  if (msg) {
    performance_test__msg__PointCloud8m__fini(msg);
  }
  free(msg);
}


bool
performance_test__msg__PointCloud8m__Sequence__init(performance_test__msg__PointCloud8m__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  performance_test__msg__PointCloud8m * data = NULL;
  if (size) {
    data = (performance_test__msg__PointCloud8m *)calloc(size, sizeof(performance_test__msg__PointCloud8m));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__PointCloud8m__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__PointCloud8m__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__PointCloud8m__Sequence__fini(performance_test__msg__PointCloud8m__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__PointCloud8m__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__PointCloud8m__Sequence *
performance_test__msg__PointCloud8m__Sequence__create(size_t size)
{
  performance_test__msg__PointCloud8m__Sequence * array = (performance_test__msg__PointCloud8m__Sequence *)malloc(sizeof(performance_test__msg__PointCloud8m__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__PointCloud8m__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
performance_test__msg__PointCloud8m__Sequence__destroy(performance_test__msg__PointCloud8m__Sequence * array)
{
  if (array) {
    performance_test__msg__PointCloud8m__Sequence__fini(array);
  }
  free(array);
}
