// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from performance_test:msg/UnboundedString.idl
// generated code does not contain a copyright notice

#ifndef PERFORMANCE_TEST__MSG__DETAIL__UNBOUNDED_STRING__FUNCTIONS_H_
#define PERFORMANCE_TEST__MSG__DETAIL__UNBOUNDED_STRING__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "performance_test/msg/rosidl_generator_c__visibility_control.h"

#include "performance_test/msg/detail/unbounded_string__struct.h"

/// Initialize msg/UnboundedString message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * performance_test__msg__UnboundedString
 * )) before or use
 * performance_test__msg__UnboundedString__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
bool
performance_test__msg__UnboundedString__init(performance_test__msg__UnboundedString * msg);

/// Finalize msg/UnboundedString message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
void
performance_test__msg__UnboundedString__fini(performance_test__msg__UnboundedString * msg);

/// Create msg/UnboundedString message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * performance_test__msg__UnboundedString__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
performance_test__msg__UnboundedString *
performance_test__msg__UnboundedString__create();

/// Destroy msg/UnboundedString message.
/**
 * It calls
 * performance_test__msg__UnboundedString__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
void
performance_test__msg__UnboundedString__destroy(performance_test__msg__UnboundedString * msg);


/// Initialize array of msg/UnboundedString messages.
/**
 * It allocates the memory for the number of elements and calls
 * performance_test__msg__UnboundedString__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
bool
performance_test__msg__UnboundedString__Sequence__init(performance_test__msg__UnboundedString__Sequence * array, size_t size);

/// Finalize array of msg/UnboundedString messages.
/**
 * It calls
 * performance_test__msg__UnboundedString__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
void
performance_test__msg__UnboundedString__Sequence__fini(performance_test__msg__UnboundedString__Sequence * array);

/// Create array of msg/UnboundedString messages.
/**
 * It allocates the memory for the array and calls
 * performance_test__msg__UnboundedString__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
performance_test__msg__UnboundedString__Sequence *
performance_test__msg__UnboundedString__Sequence__create(size_t size);

/// Destroy array of msg/UnboundedString messages.
/**
 * It calls
 * performance_test__msg__UnboundedString__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_performance_test
void
performance_test__msg__UnboundedString__Sequence__destroy(performance_test__msg__UnboundedString__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // PERFORMANCE_TEST__MSG__DETAIL__UNBOUNDED_STRING__FUNCTIONS_H_
